<!-- <p-table
  [value]="tips" 
  [loading]="loading"
  [rows]="30" 
  [showCurrentPageReport]="true"
  [scrollable]="true" scrollHeight="flex"
  dataKey="id"
  >
  <ng-template pTemplate="caption">
    <button pButton pRipple label="New Tip" icon="pi pi-plus" class="p-button-success mr-2" (click)="openNew()"></button>
  </ng-template>

  <ng-template pTemplate="header">
    <tr>
      <th pSortableColumn="text">Text
        <p-sortIcon field="text"></p-sortIcon>
      </th>
      <th pSortableColumn="date">Date
        <p-sortIcon field="date"></p-sortIcon>
      </th>
      <th>Actions</th>
    </tr>
  </ng-template>
  <ng-template pTemplate="body" let-tips let-editing="editing" let-ri="rowIndex">
    <tr [pEditableRow]="tips">
      <td>
        {{ tips.text }}
      </td>
      <td>{{ tips.date }}</td>
      <td class="tips-actions">
        <button pButton pRipple type="button" icon="pi pi-eye" (click)="showTip(tips)" class="p-button-rounded p-button-text"></button>
        <button pButton pRipple type="button" icon="pi pi-pencil" (click)="openEdit(tips)" class="p-button-rounded p-button-text"></button>
        <button pButton pRipple icon="pi pi-trash" class="p-button-rounded p-button-danger p-button-text" (click)="deleteTip(tips)"></button>
      </td>
    </tr>
  </ng-template>
</p-table> -->

<div *ngIf="isAdmin" class="new-tip-container">
  <button pButton pRipple label="New Tip" icon="pi pi-plus" class="p-button-success mr-2" (click)="openNew()"></button>
</div>
<div class="tips-container" *ngIf="tips">
  <!-- <ng-container *ngFor="let tip of tips; trackBy: trackById" >
    <p-card [header]="tip.headline" [subheader]="tip.date">
      <span class="tip-text">{{ tip.text }} </span>
      <ng-template pTemplate="footer">
        <p-button (click)="openEdit(tip)" label="Edit" icon="pi pi-pencil"></p-button>
        <p-button (click)="deletetip(tip)" label="Delete" icon="pi pi-times" styleClass="p-button-danger" [style]="{ 'margin-left': '.5em' }"></p-button>
      </ng-template>
    </p-card>
  </ng-container> -->

  <cdk-virtual-scroll-viewport itemSize="20" class="viewport">
    <ng-container *cdkVirtualFor="let tip of tips; trackBy: trackById" >
      <p-card [header]="tip.headline" [subheader]="tip.date">
        <!-- <p class="tip-text">
            {{ tip.text }} 
        </p> -->
        <span class="tip-text">{{ tip.text }} </span>
        <ng-template *ngIf="isAdmin" pTemplate="footer">
          <p-button (click)="openEdit(tip)" label="Edit" icon="pi pi-pencil"></p-button>
          <p-button (click)="deleteTip(tip)" label="Delete" icon="pi pi-times" styleClass="p-button-danger" [style]="{ 'margin-left': '.5em' }"></p-button>
        </ng-template>
      </p-card>
    </ng-container>
  </cdk-virtual-scroll-viewport>

</div>

<p-dialog [(visible)]="tipDialog" [style]="{ width: '450px' }" [header]="actionMode + ' tip'" [modal]="true" styleClass="p-fluid">
  <ng-template pTemplate="content">
      <!-- <div class="field">
          <label for="headline">Headline</label>
          <input [disabled]="actionMode === ActionMode.VIEW" type="text" pInputText id="headline" [(ngModel)]="newTip.headline" required autofocus />
          <small class="p-error" *ngIf="submitted && !newTip.headline">Headline is required.</small>
      </div> -->
      <div class="field">
        <label for="text">Text</label>
        <textarea [disabled]="actionMode === ActionMode.VIEW" rows="5" cols="30" pInputTextarea [(ngModel)]="newTip.text"></textarea>
        <small class="p-error" *ngIf="submitted && !newTip.text">Text is required.</small>
      </div>
  </ng-template>

  <ng-template pTemplate="footer">
      <button pButton pRipple label="Cancel" icon="pi pi-times" class="p-button-text" (click)="hideDialog()"></button>
      <button *ngIf="actionMode !== ActionMode.VIEW" pButton pRipple label="Save" icon="pi pi-check" class="p-button-text" (click)="saveTip()"></button>
  </ng-template>
</p-dialog>

<p-toast [breakpoints]="{'768px': {width: '90%'}}"></p-toast>
<p-confirmDialog [breakpoints]="{'768px': 'unset'}" [style]="{width: '50vw'}"></p-confirmDialog>